------------------------------------------------------------------------
-- At-most-single-hole contexts
------------------------------------------------------------------------

-- To be used with the pay functions.

module Thunk.Context where

open import Data.Nat
open import Data.Product

infixr 6 _•×_ _×•_

-- At-most-single-hole contexts.

data Ctxt : Set1 where
  •      : Ctxt
  const• : Set -> Ctxt
  Thunk• : ℕ -> Ctxt -> Ctxt
  _•×_   : Ctxt -> Set -> Ctxt
  _×•_   : Set -> Ctxt -> Ctxt

-- Fills a context. (Parameterised on the Thunk type constructor.)

fill : (ℕ -> Set -> Set) -> Ctxt -> Set -> Set
fill T •            b = b
fill T (const• a)   b = a
fill T (Thunk• n C) b = T n (fill T C b)
fill T (C •× a)     b = fill T C b × a
fill T (a ×• C)     b = a × fill T C b
